// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Suggestion;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

#[cfg(feature = "gtk_v2_18")]
#[cfg_attr(docsrs, doc(cfg(feature = "gtk_v2_18")))]
glib::wrapper! {
    #[doc(alias = "DzlSuggestionEntryBuffer")]
    pub struct SuggestionEntryBuffer(Object<ffi::DzlSuggestionEntryBuffer, ffi::DzlSuggestionEntryBufferClass>) @extends gtk::EntryBuffer;

    match fn {
        type_ => || ffi::dzl_suggestion_entry_buffer_get_type(),
    }
}

#[cfg(not(any(feature = "gtk_v2_18")))]
glib::wrapper! {
    #[doc(alias = "DzlSuggestionEntryBuffer")]
    pub struct SuggestionEntryBuffer(Object<ffi::DzlSuggestionEntryBuffer, ffi::DzlSuggestionEntryBufferClass>);

    match fn {
        type_ => || ffi::dzl_suggestion_entry_buffer_get_type(),
    }
}

impl SuggestionEntryBuffer {
    pub const NONE: Option<&'static SuggestionEntryBuffer> = None;

    #[doc(alias = "dzl_suggestion_entry_buffer_new")]
    pub fn new() -> SuggestionEntryBuffer {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::dzl_suggestion_entry_buffer_new()) }
    }
}

impl Default for SuggestionEntryBuffer {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::SuggestionEntryBuffer>> Sealed for T {}
}

pub trait SuggestionEntryBufferExt: IsA<SuggestionEntryBuffer> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_suggestion_entry_buffer_clear")]
    fn clear(&self) {
        unsafe {
            ffi::dzl_suggestion_entry_buffer_clear(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_suggestion_entry_buffer_commit")]
    fn commit(&self) {
        unsafe {
            ffi::dzl_suggestion_entry_buffer_commit(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_suggestion_entry_buffer_get_suggestion")]
    #[doc(alias = "get_suggestion")]
    fn suggestion(&self) -> Option<Suggestion> {
        unsafe {
            from_glib_none(ffi::dzl_suggestion_entry_buffer_get_suggestion(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_suggestion_entry_buffer_get_typed_length")]
    #[doc(alias = "get_typed_length")]
    fn typed_length(&self) -> u32 {
        unsafe { ffi::dzl_suggestion_entry_buffer_get_typed_length(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "dzl_suggestion_entry_buffer_get_typed_text")]
    #[doc(alias = "get_typed_text")]
    fn typed_text(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_suggestion_entry_buffer_get_typed_text(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_suggestion_entry_buffer_set_suggestion")]
    fn set_suggestion(&self, suggestion: Option<&impl IsA<Suggestion>>) {
        unsafe {
            ffi::dzl_suggestion_entry_buffer_set_suggestion(
                self.as_ref().to_glib_none().0,
                suggestion.map(|p| p.as_ref()).to_glib_none().0,
            );
        }
    }

    #[doc(alias = "suggestion")]
    fn connect_suggestion_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_suggestion_trampoline<
            P: IsA<SuggestionEntryBuffer>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntryBuffer,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SuggestionEntryBuffer::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::suggestion\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_suggestion_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<SuggestionEntryBuffer>> SuggestionEntryBufferExt for O {}

impl fmt::Display for SuggestionEntryBuffer {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("SuggestionEntryBuffer")
    }
}
